<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +--------------------------------------------------------------------+
// | The Lazym Project                                                  |
// +--------------------------------------------------------------------+
// | Copyright (c) 2004 ູѰ                                      |
// +--------------------------------------------------------------------+
// |  ҽ  Ͽ  LICENSE  LazyBoard ̼ |
// | 1.0   ֽϴ.  ̼    ּҿ  |
// | Ȯΰմϴ.                                                    |
// | http://www.lazybbs.net/license/korean__1_0.txt                     |
// | α׷̳ ̼   gonom9@gmail.com     |
// | Ͻðų http://www.lazybbs.net  湮Ͻñ ٶϴ.            |
// +--------------------------------------------------------------------+
//

/**
 * A Simple cryptography class
 */
class Crypt
{
	/**
	 * crypt key
	 * @var string
	 */
	var $_key;
	
	/**
	 * Constructor
	 *
	 * @access   private
	 */
	function crypt()
	{
		if (phpversion() < 5) $this->__construct();
	}
	
	/**
	 * @access   private
	 */
	function __construct()
	{
		// Initialize variables
		$this->_key = null;
	}
	
	function &Singleton()
	{
		static $instance;

		if (!isset($instance)) $instance = new Crypt;
		return $instance;
	}
	
	/**
	 * Execute encrypting
	 *
	 * @param    string   $data data to encrypt
	 * @return   string   encrypted data
	 */
	function Encrypt($data)
	{
		if (is_null($this->_key) || strlen($this->_key) == 0) {
			Lazym::raiseError('You must input cryptkey!');
		} else {
			srand((double)microtime()*1000000);
			$r = md5(rand(0,28000));
			for ($i=0,$c=0,$v=''; $i < strlen($data); $i++) {
				if ($c == strlen($r)) $c = 0;
				$v .= substr($r, $c, 1).(substr($data,$i,1)^substr($r,$c,1));
				$c++;
			}
			return base64_encode($this->_EnDe($v));
		}
	}
	
	/**
	 * Execute decrypting
	 *
	 * @param string $data data to decrypt
	 * @return string decrypted data
	 */
	function Decrypt($data)
	{
		$data = $this->_EnDe(base64_decode($data));
		for ($i=0,$v=''; $i < strlen($data); $i++) {
			$md5 = substr($data,$i++,1);
			$v .= (substr($data,$i,1) ^ $md5);
		}
		return $v;
	}
	
	/**
	 * Set crypt key
	 *
	 * @param string key crypt key string
	 */
	function SetKey($key)
	{
		$this->_key = $key;
	}
	
	/**
	 * Encoding and decoding a data
	 *
	 * @param string $data data
	 * @access private
	 */
	function _EnDe($data)
	{
		$r = md5($this->_key);
		for ($i=$c=0,$v='';$i<strlen($data);$i++) {
			if ($c==strlen($r)) $c=0;
			$v .= substr($data,$i,1) ^ substr($r,$c++,1);
		}
		return $v;
	}
}
?>