<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +--------------------------------------------------------------------+
// | The Lazym Project                                                  |
// +--------------------------------------------------------------------+
// | Copyright (c) 2004 ູѰ                                      |
// +--------------------------------------------------------------------+
// |  ҽ  Ͽ  LICENSE  LazyBoard ̼ |
// | 1.0   ֽϴ.  ̼    ּҿ  |
// | Ȯΰմϴ.                                                    |
// | http://www.lazybbs.net/license/korean__1_0.txt                     |
// | α׷̳ ̼   gonom9@gmail.com     |
// | Ͻðų http://www.lazybbs.net  湮Ͻñ ٶϴ.            |
// +--------------------------------------------------------------------+
//

/**
 *	The Lazym Project
 */

// {{{ constants
define('LAZYM_DIR', dirname(__FILE__));
define('LAZYM_DEBUG', 1);
// }}}

class Lazym
{
	function lazym()
	{
	}
	
	function __construct()
	{
	}

	function _import($className)
	{
		$filepath = LAZYM_DIR.'/class.'.strtolower($className).'.php';
		if (is_readable($filepath)) {
			include_once $filepath;
		} else {
			Lazym::raiseError('"%s" file is not exists!', $filepath);
		}
	}

	function &Factory($className, $factoryName)
	{
		// php5 - self::_import()
		Lazym::_import($className);

		$args = func_get_args();
		if (count($args) < 2) $args = array();
		else array_shift($args);

		return call_user_func_array(array($className, 'Factory'), $args);
	}

	function &Singleton($className)
	{
		// php5 - self::_import()
		Lazym::_import($className);
		
		return call_user_func(array($className, 'singleton'));
	}

	function raiseError()
	{
		if (!(defined('LAZYM_DEBUG') && LAZYM_DEBUG)) return;

		$args = func_get_args();
		$message = call_user_func_array('sprintf', $args);

		// TODO : get translate message
		$message = '<div><span style="background-color:red;color:white"><b>Error</b></span> '.$message.'</div>';
		echo $message;
		exit;
	}

	function raiseWarn()
	{
		if (!(defined('LAZYM_DEBUG') && LAZYM_DEBUG)) return;

		$args = func_get_args();
		$message = call_user_func_array('sprintf', $args);

		// TODO : get translate message
		$message = '<div><span style="background-color:#FBAD6F"><b>Warning</b></span> '.$message.'</div>';
		echo $message;
	}
}
?>